       IDENTIFICATION DIVISION.
       PROGRAM-ID.  FILERC.
       AUTHOR.      SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2015 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 Simmons, Created program.
      * 1997/03/17 Simmons, Updated for SYSID.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.

      *****************************************************************
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01  VERSION-NUMBER       pic X(9)   value 'V01.00.00'.
       01  PF-ROW-23.
           05  filler           pic X(3)   value SPACES.
           05  PF-ROW-23-04     pic X(8)   value SPACES.
           05  PF-ROW-23-12     pic X(8)   value SPACES.
           05  PF-ROW-23-20     pic X(8)   value 'F3=Menu '.
           05  PF-ROW-23-28     pic X(8)   value SPACES.
           05  PF-ROW-23-36     pic X(8)   value SPACES.
           05  PF-ROW-23-44     pic X(8)   value SPACES.
           05  PF-ROW-23-52     pic X(8)   value SPACES.
           05  PF-ROW-23-60     pic X(8)   value SPACES.
           05  PF-ROW-23-68     pic X(8)   value 'F12=Esc '.
           05  filler           pic X(3)   value SPACES.

       01  EOJ-MESSAGE          pic X(50)
           value '     - Enter Tran ID . . .        completed FILERC'.

       01  RECORD-LENGTH-80     pic S9(4)  comp    value 80.
       01  DATA-RESP-CODE       pic 9(08)  comp.
       01  XCTL-RESP-CODE       pic 9(08)  comp.
       01  NUMBER-WORK-16       pic 9(16)  value 0.
       01  USER-RESP-CODE       pic 9(7)   value 0.

       01  X-EIB-MESSAGE.
           05  filler           pic X(8)   value 'EIBRESP='.
           05  X-EIB-RESP       pic 9(10)  value 0.
           05  filler           pic X(11)  value ', EIBRESP2='.
           05  X-EIB-RESP2      pic 9(10)  value 0.
           05  filler           pic X      value SPACE.
           05  X-EIB-USER-MSG   pic X(38)  value SPACES.

       01  MSGXKSDS-READ-KEY    pic X(4).
       01  MSG-LINE-1           pic X(78)  value LOW-VALUES.
       01  MSG-LINE-2           pic X(78)  value LOW-VALUES.

       01  SYS-ID               pic X(4).

       01  WORK-DATE.
           05  WORK-DATE-CC     pic X(02).
           05  WORK-DATE-YY     pic 9(02).
           05  WORK-DATE-MM     pic X(02).
           05  WORK-DATE-DD     pic 9(02).
       01  WORK-TIME.
           05  WORK-TIME-HH     pic X(02).
           05  WORK-TIME-NN     pic X(02).
           05  WORK-TIME-SS     pic X(02).
           05  WORK-TIME-TT     pic X(02).

       01  EDITED-09            pic ZZZ,ZZZ,ZZ9.

       01  Z-WORK-12            pic X(12)   value SPACES.
       01  IX-12                pic 9(3)    value 0.

       01  PROGRAM-NAME         pic x(8)    value SPACES.

       01  WS-RESPONSE         pic S9(8) comp.
       01  WS-REASON-CODE      pic S9(8) comp.

       01  LOCAL-TRAN-ID        pic X(4)    value 'FSC1'.

       01  PROGRAM-FLAGS.
           05  P-FLAG-ANIM      pic X       value 'N'.
           05  P-FLAG-JOURNAL   pic X       value 'Y'.

       01  NUMERIC-WORK-ITEMS.
           05  M-VALUE          PIC 9(3)    value 0.
           05  D-VALUE          PIC 9(3)    value 0.
       01  ONE-BYTE             PIC X.
       01  A-OK                 PIC X       value 'Y'.

          COPY FILERC1.
          COPY DFHBMSCA.
          COPY DFHAID.
      *   COPY DFHEIBLK.
          COPY FILERCB1.

      *****************************************************************
       LINKAGE SECTION.
       01  DFHCOMMAREA.
           03  LS-NEWKEY         pic X(4).
           03  filler            pic X(4096).

      *****************************************************************
       PROCEDURE DIVISION.
      *     if  P-FLAG-ANIM = 'Y'
      *         CALL 'CBL_DEBUGBREAK'
      *     end-if.

           perform CLEAR-MESSAGES

           EXEC CICS HANDLE CONDITION
                ERROR   (GENERAL-ERROR-ROUTINE)
                MAPFAIL (MAP-FAIL-ROUTINE)
                NOTFND  (GENERAL-ERROR-ROUTINE)
                END-EXEC.

           evaluate TRUE
             when EIBCALEN = ZERO
                  perform SCREEN-IO-SEND-UPDATE
             when EIBAID   = DFHPF3
                  perform END-OF-PROGRAM-03
             when EIBAID   = DFHPF9
                  perform UPDATE-FILE-STATUS-INFORMATION
             when EIBAID   = DFHPF12
                  perform END-OF-PROGRAM-12
             when EIBAID   = DFHENTER
                  perform GET-FILE-STATUS-RECORD
             when other
                  move 'Type a new request and press the ENTER key'
                  to MSG-LINE-1
                  perform RECOVERY-ROUTINE
           end-evaluate.
      *    Should never get to here...
           perform END-OF-PROGRAM-12.

      *****************************************************************
       BUILD-HEADER-INFO.
           EXEC CICS ASSIGN
                SYSID(SYS-ID)
                END-EXEC.

           move 'FILERC1 ' to SYSPAGEO
           move SYS-ID to SYS-IDO.
           perform Z-GET-DATE-AND-TIME.
           exit.

      *****************************************************************
       MSGXKSDS-READ.
           move LS-NEWKEY to MSGXKSDS-READ-KEY.
           EXEC CICS READ
                DATASET   ('MSGXKSDS')
                INTO      (MSGXKSDS-REC)
                LENGTH    (RECORD-LENGTH-80)
                RIDFLD    (MSGXKSDS-READ-KEY)
                KEYLENGTH (4)
                RESP      (DATA-RESP-CODE)
                END-EXEC.
           exit.

      *****************************************************************
       MSGXKSDS-READ-UPDATE.
           EXEC CICS READ
                DATASET   ('MSGXKSDS')
                INTO      (MSGXKSDS-REC)
                LENGTH    (RECORD-LENGTH-80)
                RIDFLD    (MSGXKSDS-READ-KEY)
                KEYLENGTH (4)
                UPDATE
                RESP      (DATA-RESP-CODE)
                END-EXEC.
           exit.

      *****************************************************************
       MSGXKSDS-REWRITE.
           EXEC CICS REWRITE
                DATASET   ('MSGXKSDS')
                FROM      (MSGXKSDS-REC)
                LENGTH    (RECORD-LENGTH-80)
                RESP      (DATA-RESP-CODE)
                END-EXEC.
           exit.

      *****************************************************************
       CLEAR-MESSAGES.
           move SPACES to MSG-LINE-1
           move SPACES to MSG-LINE-2
           move SPACES to SYSMSG1O
           move SPACES to SYSMSG2O
           exit.

      *****************************************************************
       DATA-FILE-TO-SCREEN.
           move MSGXKSDS-KEY             to NEWKEYO
           move MSGXKSDS-KEY             to CURRKEYO
           if  MSGXKSDS-DATA(1:1) = ','
               move MSGXKSDS-DATA(3:52)  to CURRDATO
               move SPACES               to CURRHEXO
           else
               move MSGXKSDS-DATA(6:49)  to CURRDATO
               move MSGXKSDS-DATA(2:2)   to CURRHEXO
           end-if
      *    move MSGXKSDS-LAST-ACTIVITY-DATE to SLZLDATO
      *    move MSGXKSDS-LAST-ACTIVITY-TIME to SLZLTIMO
      *    move MSGXKSDS-REC-STATUS      to SLZSTATO
           exit.

      *****************************************************************
       DATA-INITIALIZE-SCREEN-RECORD.
           move SPACES to NEWKEYO
                          CURRKEYO
                          CURRDATO
           exit.

      *****************************************************************
       DATA-SCREEN-TO-FILE.
      *    move NEWKEYI  to MSGXKSDS-DSN-NAME
           move CURRDATI to MSGXKSDS-DATA
      *    move SLZLDATI to MSGXKSDS-LAST-ACTIVITY-DATE
      *    move SLZLTIMI to MSGXKSDS-LAST-ACTIVITY-TIME
      *    move SLZSTATI to MSGXKSDS-REC-STATUS
           exit.

      *****************************************************************
       END-OF-PROGRAM-03.
           move 'MN1UTL  ' to PROGRAM-NAME
           perform TRANSFER-CONTROL
      *    Should never get to here...
           exit.

      *****************************************************************
       END-OF-PROGRAM-12.
           EXEC CICS SEND
                FROM   (EOJ-MESSAGE)
                LENGTH (50)
                ERASE
                END-EXEC

           EXEC CICS SEND
                CONTROL FREEKB
                END-EXEC

           EXEC CICS RETURN
                END-EXEC
           exit.

      *****************************************************************
       GENERAL-ERROR-ROUTINE.
           move '                         General Error'
             to X-EIB-USER-MSG
           add EIBRESP  to ZERO giving X-EIB-RESP
           add EIBRESP2 to ZERO giving X-EIB-RESP2
           move X-EIB-MESSAGE to MSG-LINE-2.
           perform RECOVERY-ROUTINE
      *    Should never get to here...
           exit.

      *****************************************************************
       GET-FILE-STATUS-RECORD.
           perform SCREEN-IO-GET-DATA-FOR-INQUIRY
           perform MSGXKSDS-READ

           if  DATA-RESP-CODE = ZEROS
               move 'F9=Updt ' to PF-ROW-23-44
               perform DATA-FILE-TO-SCREEN
           else
               perform DATA-INITIALIZE-SCREEN-RECORD
               move LS-NEWKEY to MSG-LINE-1
               add DATA-RESP-CODE to ZERO giving USER-RESP-CODE
               move USER-RESP-CODE to MSG-LINE-1(30:7)
               move '* Entry NOT Found'
                 to MSG-LINE-1(62:17)
               perform POST-MSG-2-EIBRESP
               perform RECOVERY-ROUTINE
           end-if.

           perform SCREEN-IO-SEND-UPDATE
      *    Should never get to here...
           exit.

      *****************************************************************
       MAP-FAIL-ROUTINE.
           move '                           Map Failure'
             to X-EIB-USER-MSG
           add EIBRESP  to ZERO giving X-EIB-RESP
           add EIBRESP2 to ZERO giving X-EIB-RESP2
           move X-EIB-MESSAGE to MSG-LINE-2.
           perform RECOVERY-ROUTINE
      *    Should never get to here...
           exit.

      *****************************************************************
       POST-MSG-2-EIBRESP.
           if  X-EIB-USER-MSG = SPACES
               move '                          EIB Response'
                 to X-EIB-USER-MSG
           end-if
           add EIBRESP  to ZERO giving X-EIB-RESP
           add EIBRESP2 to ZERO giving X-EIB-RESP2
           move X-EIB-MESSAGE to MSG-LINE-2.

           exit.

      *****************************************************************
       RECOVERY-ROUTINE.
           move MSG-LINE-1 to SYSMSG1O.
           move MSG-LINE-2 to SYSMSG2O.
           move -1 to NEWKEYL
           perform SCREEN-IO-SEND-UPDATE
      *    Should never get to here...
           exit.

      *****************************************************************
       SCREEN-IO-GET-DATA-FOR-INQUIRY.
           EXEC CICS RECEIVE
                MAP    ('FILERC1')
                MAPSET ('FILERC1')
                RESP(WS-RESPONSE)
                RESP2(WS-REASON-CODE)
                END-EXEC.

           if  NEWKEYL > ZERO
               move NEWKEYI to Z-WORK-12
               perform Z-RIGHT-ADJUST-Z-WORK-12
               move Z-WORK-12(9:4) to NEWKEYI
               move NEWKEYI to LS-NEWKEY
           else
               move 'Please enter a File Status Code...'
                 to MSG-LINE-1
               perform RECOVERY-ROUTINE
           end-if.

           if  NEWKEYI = '0009'
           and NEWHEXL > ZERO
               move 'Y' to A-OK
               add 16 to ZERO giving M-VALUE
               move ZERO to D-VALUE
               move NEWHEXI(1:1) to ONE-BYTE
               perform 2 times
                 evaluate ONE-BYTE
                   WHEN '0'  compute D-VALUE = D-VALUE + M-VALUE * 0
                   WHEN '1'  compute D-VALUE = D-VALUE + M-VALUE * 1
                   WHEN '2'  compute D-VALUE = D-VALUE + M-VALUE * 2
                   WHEN '3'  compute D-VALUE = D-VALUE + M-VALUE * 3
                   WHEN '4'  compute D-VALUE = D-VALUE + M-VALUE * 4
                   WHEN '5'  compute D-VALUE = D-VALUE + M-VALUE * 5
                   WHEN '6'  compute D-VALUE = D-VALUE + M-VALUE * 6
                   WHEN '7'  compute D-VALUE = D-VALUE + M-VALUE * 7
                   WHEN '8'  compute D-VALUE = D-VALUE + M-VALUE * 8
                   WHEN '9'  compute D-VALUE = D-VALUE + M-VALUE * 9
                   WHEN 'A'  compute D-VALUE = D-VALUE + M-VALUE * 10
                   WHEN 'B'  compute D-VALUE = D-VALUE + M-VALUE * 11
                   WHEN 'C'  compute D-VALUE = D-VALUE + M-VALUE * 12
                   WHEN 'D'  compute D-VALUE = D-VALUE + M-VALUE * 13
                   WHEN 'E'  compute D-VALUE = D-VALUE + M-VALUE * 14
                   WHEN 'F'  compute D-VALUE = D-VALUE + M-VALUE * 15
                   when other move 'N' to A-OK
                 end-evaluate
                 add 1 to ZERO giving M-VALUE
                 move NEWHEXI(2:1) to ONE-BYTE
               end-perform
               move D-VALUE to NEWKEYI(2:3)
               move '9' to NEWKEYI(1:1)
               move NEWKEYI to LS-NEWKEY
               if A-OK = 'N'
                  move 'Please enter a valid, two-byte HEX extension.'
                    to MSG-LINE-1
                 perform RECOVERY-ROUTINE
               end-if
           else
             move SPACES to NEWHEXI
           end-if.
           move NEWHEXI to CURRHEXO
           exit.

      *****************************************************************
       SCREEN-IO-GET-DATA-FOR-UPDATE.
           EXEC CICS RECEIVE
                MAP    ('FILERC1')
                MAPSET ('FILERC1')
                RESP(WS-RESPONSE)
                RESP2(WS-REASON-CODE)
                END-EXEC.

           if  NEWKEYL > ZERO
               move NEWKEYI to Z-WORK-12
               perform Z-RIGHT-ADJUST-Z-WORK-12
               move Z-WORK-12 to NEWKEYI
               move NEWKEYI to LS-NEWKEY
           end-if.
           exit.

      *****************************************************************
       SCREEN-IO-SEND-UPDATE.
           perform BUILD-HEADER-INFO
           move PF-ROW-23 to PFROW23O
           EXEC CICS SEND
                MAP    ('FILERC1')
                MAPSET ('FILERC1')
                ERASE
                END-EXEC
           move LOW-VALUES to FILERC1O
           EXEC CICS RETURN
                TRANSID (LOCAL-TRAN-ID)
                COMMAREA (FILERC1O)
                LENGTH    (80)
                END-EXEC

      *    Should never get to here...
           exit.

      *****************************************************************
       TRANSFER-CONTROL.
           EXEC CICS XCTL
                PROGRAM(PROGRAM-NAME)
                RESP(XCTL-RESP-CODE)
                END-EXEC

      *    Should never get to here...
           move 'Program not found, &&&&&&&&' to MSG-LINE-1.
           inspect MSG-LINE-1 replacing first '&&&&&&&&'
                                          by PROGRAM-NAME
           move -1 to NEWKEYL.
           perform RECOVERY-ROUTINE.
      *    exit.

      *****************************************************************
       UPDATE-FILE-STATUS-INFORMATION.
           perform SCREEN-IO-GET-DATA-FOR-UPDATE

           move NEWKEYI to MSGXKSDS-READ-KEY
           perform MSGXKSDS-READ-UPDATE

           if  DATA-RESP-CODE not = 0
               add DATA-RESP-CODE to ZERO giving NUMBER-WORK-16
               move 'ReRead Failed,  ' to MSG-LINE-1(1:16)
               move CURRKEYI           to MSG-LINE-1(16:12)
               move VERSION-NUMBER     to MSG-LINE-1(70:9)
               perform GENERAL-ERROR-ROUTINE
           end-if.

           perform DATA-SCREEN-TO-FILE

           perform Z-GET-DATE-AND-TIME
      *    move WORK-DATE to MSGXKSDS-LAST-ACTIVITY-DATE
      *    move WORK-TIME to MSGXKSDS-LAST-ACTIVITY-TIME
      *    move ZEROES to MSGXKSDS-REC-STATUS

           perform MSGXKSDS-REWRITE

           if  DATA-RESP-CODE = 0
               move
               'Update Completed, type new request and press ENTER key'
               to MSG-LINE-1(1:54)
               move MSG-LINE-1 to SYSMSG1O
               move '        ' to PF-ROW-23-44
               perform SCREEN-IO-SEND-UPDATE
           else
               add DATA-RESP-CODE to ZERO giving NUMBER-WORK-16
               move 'Update Failed,  ' to MSG-LINE-1(1:16)
               move NEWKEYI            to MSG-LINE-1(16:12)
               move VERSION-NUMBER     to MSG-LINE-1(70:9)
               perform GENERAL-ERROR-ROUTINE
           end-if.

      *    Should never get to here...
           exit.

      *****************************************************************
      * Delete all characters to the right of the first space then
      * right-adjust with zero fill. This routine works with a single,
      * twelve character field and does not require a work area.
      *****************************************************************
       Z-RIGHT-ADJUST-Z-WORK-12.
           inspect Z-WORK-12
                   replacing CHARACTERS by ' ' after initial ' '
           perform until Z-WORK-12(12:1) not = SPACE
               if  Z-WORK-12(12:1) = SPACE
                   add 11 to ZERO giving IX-12
                   perform 11 times
                     move Z-WORK-12(IX-12:1) to Z-WORK-12(IX-12 + 1:1)
                     subtract 1 from IX-12
                   end-perform
                   move ZERO to Z-WORK-12(1:1)
               end-if
           end-perform
           exit.

      *****************************************************************
       Z-GET-DATE-AND-TIME.
           accept WORK-DATE from DATE YYYYMMDD
           accept WORK-TIME from TIME

           move 'ccyy/mm/dd'   to SYSDATEO
           move WORK-DATE(1:4) to SYSDATEO(1:4)
           move WORK-DATE(5:2) to SYSDATEO(6:2)
           move WORK-DATE(7:2) to SYSDATEO(9:2)

           move 'hh:mm:ss:dd'  to SYSTIMEO
           move WORK-TIME(1:2) to SYSTIMEO(1:2)
           move WORK-TIME(3:2) to SYSTIMEO(4:2)
           move WORK-TIME(5:2) to SYSTIMEO(7:2)
           move WORK-TIME(7:2) to SYSTIMEO(10:2)

           exit.
